import 'package:flutter/material.dart';
import 'package:reorderables/reorderables.dart';

main() => runApp(MaterialApp(
  home: Home(),
));

class Home extends StatefulWidget {
  @override
  _HomeState createState() => _HomeState();
}

class _HomeState extends State<Home> {
  List list = [
    'Item 1',
    'Item 2',
    'Item 3',
  ];
  int item = 4;
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(),
      body: Builder(builder: (context) {
        ScrollController _scrollController =
          PrimaryScrollController.of(context) ?? ScrollController();

        return CustomScrollView(
          controller: _scrollController,
          slivers: <Widget>[
            ReorderableSliverList(
              delegate: ReorderableSliverChildBuilderDelegate((ctx, i) {
                return ListTile(
                  title: Text(list[i]),
                  onTap: () {},
                );
              }, childCount: list.length),
              onReorder: _onReorder,
            )
          ],
        );
      }),
      floatingActionButton: FloatingActionButton(
        child: Icon(Icons.add),
        onPressed: () {
          setState(() {
            list.add('Item ${item++}');

          });
        },
      ),
    );
  }

  _onReorder(o, n) {
    setState(() {
      var row = list.removeAt(o);
      list.insert(n, row);
    });
  }
}